%bcond_without perl_Convert_ASN1_enables_optional_test
Summary:             ASN.1 encode/decode library
Name:                perl-Convert-ASN1
Version:             0.33
Release:             2
License:             GPL+ or Artistic
URL:                 https://metacpan.org/release/Convert-ASN1
Source0:             https://cpan.metacpan.org/authors/id/T/TI/TIMLEGGE/Convert-ASN1-%{version}.tar.gz
Patch0:              Convert-ASN1-0.27-Use-temporary-output-files-for-tests.patch
BuildArch:           noarch
BuildRequires:       coreutils make perl-generators perl-interpreter
BuildRequires:       perl(ExtUtils::MakeMaker) >= 6.76 perl(strict) perl(warnings)
BuildRequires:       perl(:VERSION) >= 5.4 perl(Carp) perl(constant) perl(Encode) perl(Exporter)
BuildRequires:       perl(POSIX) perl(Socket) perl(Time::Local) perl(utf8) perl(vars) perl(bytes)
BuildRequires:       perl(File::Temp) perl(IO::Socket) perl(Math::BigInt) >= 1.997 perl(Test::More) >= 0.90
%if %{with perl_Convert_ASN1_enables_optional_test}
BuildRequires:       perl(Data::Dumper)
%endif
Requires:            perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Suggests:            perl(bytes)
Requires:            perl(Carp) perl(Encode) perl(POSIX) perl(Time::Local) perl(utf8)
%global __requires_exclude %{?__requires_exclude:%{__requires_exclude}|}^perl\\(Math::BigInt\\)$
%description
Convert::ASN1 encodes and decodes ASN.1 data structures using BER/DER rules.

%package tests
Summary:             Tests for %{name}
Requires:            %{name} = %{?epoch:%{epoch}:}%{version}-%{release} perl-Test-Harness
Requires:            perl(Math::BigInt) >= 1.997
%if %{with perl_Convert_ASN1_enables_optional_test}
Requires:            perl(Data::Dumper)
%endif
%description tests
Tests from %{name}-%{version}. Execute them
with "%{_libexecdir}/%{name}/test".

%prep
%setup -q -n Convert-ASN1-%{version}
%patch0 -p1

for F in t/*.t; do
    perl -i -MConfig -ple 'print $Config{startperl} if $. == 1 && !s{\A#!.*perl\b}{$Config{startperl}}' "$F"
    chmod +x "$F"
done

%build
perl Makefile.PL INSTALLDIRS=vendor NO_PACKLIST=1 NO_PERLLOCAL=1
%{make_build}

%install
%{make_install}
mkdir -p %{buildroot}/%{_libexecdir}/%{name}
cp -a t %{buildroot}/%{_libexecdir}/%{name}
cat > %{buildroot}/%{_libexecdir}/%{name}/test << 'EOF'
cd %{_libexecdir}/%{name} && exec prove -I . -j "$(getconf _NPROCESSORS_ONLN)"
EOF
chmod +x %{buildroot}/%{_libexecdir}/%{name}/test
%{_fixperms} %{buildroot}/*

%check
unset YYDEBUG
export HARNESS_OPTIONS=j$(perl -e 'if ($ARGV[0] =~ /.*-j([0-9][0-9]*).*/) {print $1} else {print 1}' -- '%{?_smp_mflags}')
make test

%files
%license LICENSE
%doc ChangeLog OldChanges README.md examples/
%{perl_vendorlib}/Convert/
%{_mandir}/man3/*.3pm*

%files tests
%{_libexecdir}/%{name}

%changelog
* Thu Nov 10 2022 caodongxia <caodongxia@h-partners.com> - 0.33-2
- Modify invalid source0

* Wed May 18 2022 liyanan <liyanan@h-partners.com>- 0.33-1
- update to 0.33

* Sat Feb 20 2021 sunguoshuai <sunguoshuai@huawei.com> - 0.27-1
- package init
